"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class AppObjectFactory {
    static cleanAddElements(tag) {
        if (AppObjectFactory.numberOfElements(tag) === 0 && document.getElementsByTagName(tag).length > 0) {
            AppObjectFactory.addElements(tag, document.getElementsByTagName(tag).length);
        }
    }
    static addElements(tag, number) {
        if (AppObjectFactory.elementTypes[tag] === null || AppObjectFactory.elementTypes[tag] === undefined) {
            AppObjectFactory.elementTypes[tag] = new Array();
        }
        for (let index = 0; index < number; index++) {
            AppObjectFactory.elementTypes[tag].push('' + tag + 'Id' + AppObjectFactory.elementTypes[tag].length);
        }
    }
    static addElement(tag) {
        if (AppObjectFactory.elementTypes[tag] === null || AppObjectFactory.elementTypes[tag] === undefined) {
            AppObjectFactory.elementTypes[tag] = new Array();
        }
        AppObjectFactory.elementTypes[tag].push('' + tag + 'Id' + AppObjectFactory.elementTypes[tag].length);
    }
    static createElement(tag, id, sVG) {
        let element;
        AppObjectFactory.clear(document.getElementById(id));
        if (tag === 'body') {
            element = document.body;
        }
        else {
            element = AppObjectFactory.newElement(tag, sVG);
        }
        element.id = id;
        return element;
    }
    static clear(element) {
        if (element)
            element.innerHTML = '';
    }
    static numberOfElements(tag) {
        let number = 0;
        if (AppObjectFactory.elementTypes[tag] === null || AppObjectFactory.elementTypes[tag] === undefined) {
            AppObjectFactory.elementTypes[tag] = new Array();
        }
        number = AppObjectFactory.elementTypes[tag].length;
        return number;
    }
    static create(className, geneticCode) {
        let object;
        // console.log('object = window.exports.' + className + '.getInstance(father);');
        // tslint:disable-next-line: no-eval
        object = eval('window.exports.' + className + '.' + 'getInstance(geneticCode)');
        return object;
    }
    static newElement(tag, sVG) {
        let element;
        if (sVG) {
            element = document.createElementNS('http://www.w3.org/2000/svg', tag);
        }
        else {
            element = document.createElement(tag);
        }
        return element;
    }
}
exports.AppObjectFactory = AppObjectFactory;
AppObjectFactory.elementTypes = {};
//# sourceMappingURL=appObjectFactory.js.map