"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const attribute_1 = require("./attribute");
const ko = require("knockout");
const appObjectFactory_1 = require("../appObject/factory/appObjectFactory");
class BasicViewModel {
    constructor(geneticCode) {
        let _self = this;
        if (geneticCode.arrayBindHandlers)
            for (let index = 0; index < geneticCode.arrayBindHandlers.length; index++)
                this.addBindHandler(geneticCode.arrayBindHandlers[index]);
        this.arrayAttribute = new Array();
        appObjectFactory_1.AppObjectFactory.cleanAddElements(geneticCode.tag);
        let nodes = appObjectFactory_1.AppObjectFactory.numberOfElements(geneticCode.tag);
        _self.element = appObjectFactory_1.AppObjectFactory.createElement(geneticCode.tag, geneticCode.tag + 'Id' + nodes, geneticCode.sVG);
        _self.sVG = geneticCode.sVG;
        appObjectFactory_1.AppObjectFactory.addElement(geneticCode.tag);
        if (geneticCode.arrayType)
            for (let index = 0; index < geneticCode.arrayType.length; index++) {
                const type = geneticCode.arrayType[index];
                const attribute = new attribute_1.Attribute(type, type + _self.element.id);
                this.addBind(attribute);
            }
    }
    getElement() {
        return this.element;
    }
    initAttributeValue(attribute) {
        // tslint:disable-next-line: no-eval
        eval(attribute.getInit());
    }
    setAttributeValue(attributeName, value) {
        // tslint:disable-next-line: no-eval
        eval(this.arrayAttribute.find(attribute => attribute.getName() === attributeName).getSet(value));
    }
    applyBindings() {
        let _self = this;
        ko.applyBindings(_self, _self.element); // receive BasicModel in constructor and save
    }
    resetAllAttributeValue() {
        let _self = this;
        for (let index = 0; index < this.arrayAttribute.length; index++) {
            const attribute = this.arrayAttribute[index];
            _self.initAttributeValue(attribute);
        }
    }
    init() {
        let _self = this;
        _self.resetAllAttributeValue();
        _self.applyBindings();
    }
    addBind(attribute) {
        this.arrayAttribute.push(attribute);
        let dataBind = this.element.getAttribute('data-bind');
        if (dataBind)
            this.element.setAttribute('data-bind', dataBind + ',' + attribute.getLink());
        else
            this.element.setAttribute('data-bind', attribute.getLink());
    }
    addBindHandler(bindHandler) {
        let _self = this;
        ko.bindingHandlers[bindHandler] = {
            init: function (element, valueAccessor, allBindingsAccessor) {
                let underlyingObservable = valueAccessor();
                let binding = { attr: {} };
                binding.attr[bindHandler] = underlyingObservable;
                ko.applyBindingsToNode(element, binding, _self);
            }
        };
    }
}
exports.BasicViewModel = BasicViewModel;
//# sourceMappingURL=basicViewModel.js.map