"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class Child {
    constructor(geneticCode) {
        let _self = this;
        _self.arrayChild = ko.observableArray();
        _self.arrayChild.subscribe((changes) => {
            _self.arrayChange(changes);
        }, null, 'arrayChange');
        _self.getArrayChild = _self.arrayChild();
        _self.className = 'Child';
        if (!geneticCode)
            geneticCode = {};
        if (geneticCode.className)
            _self.className = geneticCode.className;
        _self.initGeneticCode(geneticCode);
        if (geneticCode.father)
            if (geneticCode.position)
                geneticCode.father.setChild({ child: _self, index: geneticCode.position, jSON: geneticCode.jSON });
            else
                geneticCode.father.addChild({ child: _self, jSON: geneticCode.jSON });
    }
    populate(jSON) {
    }
    seekVariable(name) {
        if (this[name] !== undefined)
            return this[name];
        if (this.father !== undefined)
            return this.father.seekVariable(name);
        return undefined;
    }
    getChildAt(index) {
        return this.getArrayChild[index];
    }
    getChildrenLength() {
        return this.getArrayChild.length;
    }
    addChild({ child, index, jSON }) {
        this.initChild(child, jSON);
        if (index) {
            this.arrayChild.splice(index, 0, child);
        }
        else {
            this.arrayChild.push(child);
        }
    }
    spliceChild(start, deleteCount, ...children) {
        for (let index = 0; index < children.length; index++) {
            const child = children[index];
            this.initChild(child);
        }
        this.arrayChild.splice(start, deleteCount, ...children);
    }
    setChild({ child, index, jSON }) {
        this.initChild(child, jSON);
        this.arrayChild.splice(index, 1, child);
    }
    getFather() {
        return this.father;
    }
    setFather(father) {
        let _self = this;
        if (_self.father !== father) {
            if (_self.father && _self.father instanceof appObject_1.AppObject) {
                _self.father.spliceChild(_self.father.getArrayChild.findIndex((element) => { return element === _self; }), 1);
            }
            else if (_self.father && _self.father.father instanceof component_1.Component) {
                // destroy just this child from old father
                _self.father.father.destroyChildElements();
            }
            _self.father = father;
        }
    }
    getClassName() {
        return this.className;
    }
    seekFather(className) {
        if (this.father !== undefined) {
            // console.log('FATHER NAME:' + this.father.getClassName());
            if (this.father.getClassName() === 'ComponentGeneric') {
                if (this.father.getClassName() === 'ComponentGeneric') {
                    if (this.father.generateMap(className)) {
                        if (this.father.generateMap(className).tag === this.father.getTag()) {
                            return this.father;
                        }
                    }
                    else {
                        return this.father.seekFather(className);
                    }
                }
            }
            else if (this.father.getClassName() === className) {
                return this.father;
            }
            else {
                return this.father.seekFather(className);
            }
        }
        return undefined;
    }
    getChild(className) {
        for (let index = 0; index < this.getChildrenLength(); index++) {
            const child = this.getArrayChild[index];
            if (child.className === className) {
                return child;
            }
        }
        return undefined;
    }
    getAllChildren(className) {
        let array = new Array();
        for (let index = 0; index < this.getChildrenLength(); index++) {
            const child = this.getArrayChild[index];
            if (child.className === className) {
                array.push(child);
            }
        }
        return array;
    }
    remove(child) {
    }
    insert(child) {
    }
    renderAfterUpdate() {
    }
    initGeneticCode(geneticCode) {
        let _self = this;
        let arrayBindHandlers;
        if (_self.properties && geneticCode.arrayType) {
            arrayBindHandlers = [...geneticCode.arrayType];
            for (const property of Object.keys(_self.properties)) {
                Array.cleanPush(geneticCode.arrayType, property);
                if (property !== 'text')
                    Array.cleanPush(arrayBindHandlers, property);
            }
        }
        geneticCode.arrayBindHandlers = arrayBindHandlers;
        return geneticCode;
    }
    initChild(child, jSON) {
        child.setFather(this);
        if (jSON)
            child.populate(jSON);
    }
    arrayChange(changes) {
        for (let index = 0; index < changes.length; index++) {
            const change = changes[index];
            // TODO missing status
            switch (change.status) {
                case 'added':
                    this.initChild(change.value);
                    this.insert(change.value);
                    this.renderAfterUpdate();
                    break;
                case 'deleted':
                    this.remove(change.value);
                    this.renderAfterUpdate();
                    break;
                default:
                    break;
            }
        }
    }
}
exports.Child = Child;
const component_1 = require("../component/component");
const ko = require("knockout");
const appObject_1 = require("../appObject/appObject");
//# sourceMappingURL=child.js.map