"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const component_1 = require("./common/component/component");
const componentPageBody_1 = require("./body/componentPageBody");
const componentRouter_1 = require("./common/component/generic/router/componentRouter");
class ComponentView extends component_1.Component {
    static clear() {
        let range = document.createRange();
        range.selectNodeContents(document.getElementsByTagName('body')[0]);
        range.deleteContents();
    }
    constructor(geneticCode) {
        // ComponentView.clear();
        super(Object.assign({ className: 'ComponentView', tag: 'body' }, geneticCode));
        this.resetHeader();
        this.resetNotification();
        this.resetPageBody();
        this.resetFooter();
    }
    goToPage(pageName) {
        this.getPageBody().pageName = pageName;
    }
    getHeader() {
        return this.getChildAt(0);
    }
    getNotification() {
        return this.getChildAt(1);
    }
    getPageBody() {
        return this.getChildAt(2);
    }
    getFooter() {
        return this.getChildAt(3);
    }
    resetHeader() {
        if (this.getHeader())
            this.getHeader().destroyElement();
        let componentRouter = new componentRouter_1.ComponentRouter({ father: this, position: 0, specificName: 'ComponentHeader', routerName: 'header', nextName: '', suffix: '', main: 'header' });
    }
    resetNotification() {
        if (this.getNotification())
            this.getNotification().destroyElement();
        let componentRouter = new componentRouter_1.ComponentRouter({ father: this, position: 1, specificName: 'ComponentNotification', routerName: 'notification', nextName: 'none', suffix: 'Notification', main: 'none' });
    }
    resetPageBody() {
        if (this.getPageBody())
            this.getPageBody().destroyElement();
        let componentRouter = new componentPageBody_1.ComponentPageBody({ father: this, position: 2 });
    }
    resetFooter() {
        if (this.getFooter())
            this.getFooter().destroyElement();
        let componentRouter = new componentRouter_1.ComponentRouter({ father: this, position: 3, specificName: 'ComponentFooter', routerName: 'footer', nextName: '', suffix: '', main: 'footer' });
    }
}
exports.ComponentView = ComponentView;
ComponentView.addConstructor(ComponentView);
//# sourceMappingURL=componentView.js.map