"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
// export = 0;
class ImportScript {
    static importTS(path) {
        this.importJS(path);
    }
    static importJS(path) {
        this.importFile(path, 'js');
    }
    static importJSON(path) {
        this.importFile(path, 'json');
    }
    static importCSS(path) {
        this.importFile(path, 'css');
    }
    static type(format) {
        switch (format) {
            case 'css':
                return 'link';
            case 'js':
                return 'script';
            default:
                return 'script';
        }
    }
    static attributeSource(format) {
        switch (format) {
            case 'css':
                return 'href';
            case 'js':
                return 'src';
            default:
                return 'src';
        }
    }
    static importFile(path, format) {
        this.importFileWithoutExtention(path + '.' + format, format, false, false);
    }
    static importFileWithoutExtention(path, format, async, defer) {
        let importedScript = document.createElement(this.type(format));
        let fullPath = path;
        let source = this.attributeSource(format);
        if (async) {
            importedScript.setAttribute('async', '');
        }
        if (defer) {
            importedScript.setAttribute('defer', '');
        }
        importedScript.setAttribute(source, fullPath);
        if (format === 'css') {
            importedScript.setAttribute('rel', 'stylesheet');
            importedScript.setAttribute('type', 'text/css');
        }
        let nodes = document.head.children;
        for (let index = 0; index < nodes.length; index++) {
            let element = nodes[index];
            if (element.getAttribute(source) === importedScript.getAttribute(source)) {
                return;
            }
        }
        document.head.appendChild(importedScript);
    }
    static importFileWithoutExtentionWithCallback(path, format, name, callback) {
        this.importFileWithoutExtention(path + '&callback=callbacker' + name, format, true, true);
        window['callbacker' + name] = callback;
    }
}
exports.ImportScript = ImportScript;
//# sourceMappingURL=importScript.js.map